unit Test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Starts another application . waits for it's end if DoWait = true
// returns errorcode of application, resp -1 in case of start error
// for Visibility lookup help for ShowWindow or use SW_SHOW

function WinExec32(FileName: string; Visibility: integer; DoWait : boolean = false ): integer;
var
  zAppName: array[0..512] of char;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  Res : DWORD;
begin
  StrPCopy(zAppName, FileName);
  FillChar(StartupInfo, Sizeof(StartupInfo), #0);
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if CreateProcess (nil,
                    zAppName, { pointer to command line string }
                    nil, { pointer to process security attributes }
                    nil, { pointer to thread security attributes }
                    false, { handle inheritance flag }
                    CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, { creation flags }
                    nil, { pointer to new environment block }
                    nil, { pointer to current directory name }
                    StartupInfo, { pointer to STARTUPINFO }
                    ProcessInfo) then { pointer to PROCESS_INF }
    begin
      if DoWait then
        begin
          WaitforSingleObject(ProcessInfo.hProcess, INFINITE);
          GetExitCodeProcess(ProcessInfo.hProcess, Res);
          Result:=Res;
        end
      else
        begin
          Result:=0;
        end;
      CloseHandle(ProcessInfo.hProcess);
      CloseHandle(ProcessInfo.hThread);
    end
  else
    begin
      Result := -1
    end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var Res: integer;
begin
//  Res := WinExec32('notepad.exe', SW_HIDE, true);
  Res := WinExec32('CommandLine "command1 command2 command3 command4 command5"', SW_SHOW, true);
  ShowMessage('Result code: ' + inttostr(Res))
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
